       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGPUAN.
       SECURITY.      Puan Durumu Hesaplama ve Tablosu.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 EKR-AVERAJ PIC S99   VALUE ZEROS.
       77 EKR-HAFTA  PIC 99    VALUE ZEROS.
       77 ESCKOD     PIC 99    VALUE ZEROS.
       77 SAT        PIC 99    VALUE ZEROS.
       77 SAYAC      PIC 99    VALUE ZEROS.
       77 SATIR1     PIC X(76) VALUE SPACES.
       77 INTX       PIC 9     COMP-0 VALUE 0.
       01 DEG PIC 9(4) VALUE 0.
           88 ESC VALUE 6912. 88 F1  VALUE 5104. 88 F2  VALUE 5360.
       01 BUGUN. 02 BU-YIL PIC 99. 02 BU-AY PIC 99. 02 BU-GUN PIC 99.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 PUAN-BILGILERI.
           02 LINE SAT COLUMN 13 PIC ZZ FROM SAYAC.
           02          COLUMN 15 ".".
           02          COLUMN 16 PIC X(20) FROM TAKIM-ADI.
           02          COLUMN 38 PIC ZZ9 FROM TAKIM-OYNADIGI.
           02          COLUMN 42 PIC ZZ9 FROM TAKIM-GALIBIYET.
           02          COLUMN 46 PIC ZZ9 FROM TAKIM-BERABERLIK.
           02          COLUMN 50 PIC ZZ9 FROM TAKIM-MAGLUBIYET.
           02          COLUMN 54 PIC ZZ9 FROM TAKIM-ATTIGI.
           02          COLUMN 58 PIC ZZ9 FROM TAKIM-YEDIGI.
           02          COLUMN 62 PIC --9 FROM EKR-AVERAJ.
           02          COLUMN 66 PIC ZZ9 FROM TAKIM-PUAN.
       01 PUAN-BILGILERI-BOS.
           02 LINE SAT COLUMN 13 "   ".
           02          COLUMN 16 "                    ".
           02          COLUMN 38 "   ".
           02          COLUMN 42 "   ".
           02          COLUMN 46 "   ".
           02          COLUMN 50 "   ".
           02          COLUMN 54 "   ".
           02          COLUMN 58 "   ".
           02          COLUMN 62 "   ".
           02          COLUMN 66 "   ".
       01 PUAN-DURUMU REVERSE-VIDEO.
           02 LINE 01 COLUMN 03 PIC X(76) FROM SATIR1.
           02 LINE 24 COLUMN 13 PIC X(56) FROM SATIR1.
           02 LINE 01 COLUMN 35 " PUAN DURUMU ".
           02         COLUMN 04 PIC X(30) FROM LIG-ADI.
           02         COLUMN 70 PIC ZZ/ FROM BU-GUN.
           02         COLUMN 73 PIC ZZ/ FROM BU-AY.
           02         COLUMN 76 PIC ZZ  FROM BU-YIL.
           02 LINE 24 COLUMN 14
              " Genel Puan Durumu <F1>, Ksmi P.D.<F2>, k <Esc> ".
       01 HAFTA-AL EMPTY-CHECK REVERSE-VIDEO.
           02 LINE 17 COLUMN 42 PIC ZZ USING EKR-HAFTA.
       01 NO-CURSOR REVERSE-VIDEO.
           02 LINE 01 COLUMN 03 " ".
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           DISPLAY (1,1) ERASE.
           DISPLAY '~C=ALL/'.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=LIGPUAN,NOWAIT/'.
       EKRAN-HAZIRLA.
           PERFORM LIG-VE-TARIHI-AL.
           DISPLAY PUAN-DURUMU.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                    PUAN DURUMUNU YAZDIRMA                   * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PUAN-DURUMUNU-YAZ.
           PERFORM SAYFA-TEMIZLE VARYING SAT FROM 5 BY 1 UNTIL SAT>21.
           MOVE 4 TO SAT. MOVE 0 TO SAYAC.
           MOVE 999 TO TAKIM-PUAN-KEY TAKIM-NO.
           OPEN INPUT TAKIMDOS.
           START TAKIMDOS KEY LESS THAN PUAN-KEY 
                                 INVALID GO PUAN-DURUMU-SON.
       PUAN-DURUMU-OKU.
           READ TAKIMDOS PREVIOUS AT END GO PUAN-DURUMU-SON.
           ADD 1 TO SAT SAYAC.
           COMPUTE EKR-AVERAJ=TAKIM-ATTIGI - TAKIM-YEDIGI.
           DISPLAY PUAN-BILGILERI.
           IF SAT>21 GO PUAN-DURUMU-SON.
           GO PUAN-DURUMU-OKU.
       PUAN-DURUMU-SON.
           CLOSE TAKIMDOS.
       PUAN-DURUMU-SON-DEVAM.
           DISPLAY NO-CURSOR. CALL X"83" USING INTX. MOVE INTX TO DEG.
           IF ESC GO PROGRAM-SONU.
           IF F1  MOVE 99 TO EKR-HAFTA GO PUAN-DURUMU-HESAPLA.
           IF F2  MOVE 0  TO EKR-HAFTA GO PUAN-HAFTA-OKU.
           GO PUAN-DURUMU-SON-DEVAM.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                    PUAN DURUMUNU HESAPLAMA                  * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PUAN-DURUMU-HESAPLA. DISPLAY (2,2) " ".
           DISPLAY '~W=PUANHES,NOWAIT/'.
           OPEN I-O TAKIMDOS.
           MOVE ZEROS TO TAKIM-NO.
           START TAKIMDOS KEY NOT LESS THAN TAKIM-KEY 
                             INVALID GO FIKS-START.
       TAKIM-OKU.
           READ TAKIMDOS NEXT AT END GO FIKS-START.
           MOVE ZEROS TO TAKIM-PUAN-KEY TAKIM-OYNADIGI TAKIM-GALIBIYET
                         TAKIM-BERABERLIK TAKIM-MAGLUBIYET TAKIM-YEDIGI.
           REWRITE TAKIM-KAYDI.
           GO TAKIM-OKU.
       FIKS-START.
           OPEN INPUT FIKSDOS.
           MOVE ZEROS TO FIKS-HAFTA-NO FIKS-MAC-NO.
           START FIKSDOS KEY NOT LESS THAN FIKS-KEY
                            INVALID GO FIKS-SON.
       FIKS-OKU.
           READ FIKSDOS NEXT AT END GO FIKS-SON.
      *> Ksmi Hesaplama Kontrol.
           IF FIKS-HAFTA-NO>EKR-HAFTA GO FIKS-SON.
      *> Man oynanp oynanmadnn kontrol.
           IF FIKS-TEST=0 GO FIKS-OKU.

      *> 1. Takm Hesaplamalar.
           MOVE FIKS-TAKIM1 TO TAKIM-NO.
           READ TAKIMDOS INVALID DISPLAY (2,2) "*".
           ADD 1 TO TAKIM-OYNADIGI.
           ADD FIKS-SONUC1 TO TAKIM-ATTIGI.
           ADD FIKS-SONUC2 TO TAKIM-YEDIGI.
      *> Negatif Averajlarn srasn ard iin 500 ekleniyor.
           COMPUTE TAKIM-AVERAJ=(TAKIM-ATTIGI - TAKIM-YEDIGI) + 500.
           IF FIKS-SONUC1=FIKS-SONUC2
                   ADD 1 TO TAKIM-BERABERLIK
                   ADD LIG-BERABERLIK TO TAKIM-PUAN.
           IF FIKS-SONUC1 > FIKS-SONUC2
                   ADD 1 TO TAKIM-GALIBIYET
                   ADD LIG-GALIBIYET TO TAKIM-PUAN.
           IF FIKS-SONUC1 < FIKS-SONUC2
                   ADD 1 TO TAKIM-MAGLUBIYET
                   ADD LIG-MAGLUBIYET TO TAKIM-PUAN.
           REWRITE TAKIM-KAYDI.

     $*> 2. Takm Hesaplamalar.
           MOVE FIKS-TAKIM2 TO TAKIM-NO.
           READ TAKIMDOS INVALID DISPLAY (2,2) "*".
           ADD 1 TO TAKIM-OYNADIGI.
           ADD FIKS-SONUC2 TO TAKIM-ATTIGI.
           ADD FIKS-SONUC1 TO TAKIM-YEDIGI.
      *> Negatif Averajlarn srasn ard iin 500 ekleniyor.
           COMPUTE TAKIM-AVERAJ=(TAKIM-ATTIGI - TAKIM-YEDIGI) + 500.
           IF FIKS-SONUC2=FIKS-SONUC1
                   ADD 1 TO TAKIM-BERABERLIK
                   ADD LIG-BERABERLIK TO TAKIM-PUAN.
           IF FIKS-SONUC2 > FIKS-SONUC1
                   ADD 1 TO TAKIM-GALIBIYET
                   ADD LIG-GALIBIYET TO TAKIM-PUAN.
           IF FIKS-SONUC2 < FIKS-SONUC1
                   ADD 1 TO TAKIM-MAGLUBIYET
                   ADD LIG-MAGLUBIYET TO TAKIM-PUAN.
           REWRITE TAKIM-KAYDI.
           GO FIKS-OKU.
       FIKS-SON.
           CLOSE TAKIMDOS FIKSDOS.
           DISPLAY '~C=LAST/'.
           GO PUAN-DURUMUNU-YAZ.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                  KISM PUAN DURUMU HESAPLAMA                * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PUAN-HAFTA-OKU.
           DISPLAY '~W=HAFTAOKU,NOWAIT/'.
           DISPLAY HAFTA-AL.
       HAFTA-OKU.
           ACCEPT HAFTA-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
           IF ESCKOD=01 DISPLAY "~C=LAST/" GO PUAN-DURUMU-SON-DEVAM.
           IF EKR-HAFTA > (SAYAC * 2 - 2) OR ESCKOD NOT=0 GO HAFTA-OKU.
           DISPLAY "~C=LAST/".
           GO PUAN-DURUMU-HESAPLA.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      *> Alt Perform Sahalar.
       LIG-VE-TARIHI-AL.
           ACCEPT BUGUN FROM DATE.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-ADI
                                     MOVE ZEROS  TO LIG-PUAN-SISTEMI
                     ELSE READ LIGDOS AT END DISPLAY (2,2) "*".
           CLOSE LIGDOS.
       SAYFA-TEMIZLE.
           DISPLAY PUAN-BILGILERI-BOS.
      *> Programdan k.
       PROGRAM-SONU.
           EXIT PROGRAM.
