       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGTAKIM.
       SECURITY.      Takm lemleri.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 EKR-TAKIM-NO PIC 9(2) VALUE ZEROS.
       77 KARAR        PIC 9    VALUE 0.
       01 BUGUNUN-TARIHI.
           02 BU-YIL PIC 99. 02 BU-AY PIC 99. 02 BU-GUN PIC 99.
       01 ESCKOD PIC 99.
           88 ASAGI VALUE 00. 88 ESC    VALUE 01.
           88 F2    VALUE 03. 88 F3     VALUE 04. 88 F8 VALUE 09.
           88 F10   VALUE 11. 88 YUKARI VALUE 99.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
      * Tablo Deikenleri.
       01 TAKIM-DIZISI.
           02 TAKIM-DIZI-DATA    OCCURS 18 TIMES.
               03 TAKIM-DIZI-NO  PIC Z(2)  VALUE ZEROS.
               03 TAKIM-DIZI-ADI PIC X(20) VALUE SPACES.
       77 TAB-LIN   PIC 99 VALUE 0.
       77 TAB-SAY   PIC 99 VALUE 0.
       77 TAB-SECIM PIC 99 VALUE 1.
       77 TAB-ESSEC PIC 99 VALUE 1.
       77 TAB-INTX  PIC 9  COMP-0 VALUE 0.
       01 TAB-DEG   PIC 9(4) VALUE 0.
           88 TAB-ESC   VALUE 6912. 88 TAB-ENTER  VALUE 3328.
           88 TAB-ASAGI VALUE 0480. 88 TAB-YUKARI VALUE 8432.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 TAKIM-NO-AL REVERSE-VIDEO.
           02 LINE 06 COLUMN 36 PIC Z(2) USING EKR-TAKIM-NO.
       01 TAKIM-BILGILERI REVERSE-VIDEO.
           02 LINE 06 COLUMN 36 PIC Z(2) FROM EKR-TAKIM-NO.
           02 LINE 08 COLUMN 36 PIC X(20) USING TAKIM-ADI.
       01 TAKIM-ISLEMLERI REVERSE-VIDEO.
           02 LINE 01 COLUMN 25 " T A K I M    L E M L E R  ".
      *> Takm Tablosunda Ik Kontrolleri.
       01 NORMAL-TAKIM-YAZ.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM TAKIM-DIZI-NO (TAB-ESSEC).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM TAKIM-DIZI-ADI(TAB-ESSEC).
       01 PARLAK-TAKIM-YAZ REVERSE-VIDEO.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM TAKIM-DIZI-NO (TAB-SECIM).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM TAKIM-DIZI-ADI(TAB-SECIM).
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           DISPLAY (1,1) ERASE.
           DISPLAY "~C=ALL/".
           DISPLAY "~L=LIGMENU/".
           DISPLAY "~W=LIGTAKIM,NOWAIT,NOESC/".
           DISPLAY TAKIM-ISLEMLERI.
           PERFORM LIG-VE-TARIHI-YAZ.
           PERFORM SIFIRLA.
           DISPLAY TAKIM-BILGILERI.
       TAKIM-NO-OKU.
           PERFORM OTOMATIK-TAKIM-NO THRU OTOMATIK-SON.
           ACCEPT TAKIM-NO-AL. PERFORM ESC-AL. IF ESC GO PROGRAM-SONU.
           IF F2  GO SONRAKI-KAYIT. 
           IF F3  GO ONCEKI-KAYIT.
           IF F10 PERFORM TAKIM-TABLOSU THRU TAKIM-TABLO-SON 
                  GO DOSYA-KONTROL.
           IF EKR-TAKIM-NO=ZEROS OR NOT ASAGI GO TAKIM-NO-OKU.
       DOSYA-KONTROL.
           IF EKR-TAKIM-NO=ZEROS OR >18 GO TAKIM-NO-OKU.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           READ TAKIMDOS INVALID CLOSE TAKIMDOS GO TAKIM-GIRIS.
           CLOSE TAKIMDOS.
           DISPLAY TAKIM-BILGILERI.
           GO TAKIM-DUZELT.
       TAKIM-GIRIS.
           PERFORM SIFIRLA. DISPLAY TAKIM-BILGILERI.
       GIRIS-BILGI-OKU.
           ACCEPT TAKIM-BILGILERI. PERFORM ESC-AL.
           IF ESC OR YUKARI GO TAKIM-NO-OKU.
           IF TAKIM-ADI=SPACES OR NOT ASAGI GO GIRIS-BILGI-OKU.
       GIRIS-KAYDET.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           MOVE ZEROS TO TAKIM-PUAN TAKIM-AVERAJ TAKIM-ATTIGI
                         TAKIM-OYNADIGI TAKIM-GALIBIYET TAKIM-BERABERLIK
                         TAKIM-MAGLUBIYET TAKIM-YEDIGI.
           OPEN I-O TAKIMDOS.
           WRITE TAKIM-KAYDI INVALID DISPLAY (2,2) "*".
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
       TAKIM-DUZELT.
           ACCEPT TAKIM-BILGILERI. PERFORM ESC-AL.
           IF ESC OR YUKARI GO TAKIM-NO-OKU. IF F8 GO TAKIM-IPTAL.
           IF TAKIM-ADI=SPACES OR NOT ASAGI GO TAKIM-DUZELT.
       DUZELT-KAYDET.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           OPEN I-O TAKIMDOS.
           REWRITE TAKIM-KAYDI INVALID DISPLAY (2,2) "*".
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
       TAKIM-IPTAL.
           DISPLAY "~W=IPTEMIN,NOESC/".
           ACCEPT (2,2) KARAR WITH AUTO-SKIP. PERFORM ESC-AL.
           IF ESC GO TAKIM-NO-OKU. DISPLAY (2,2) " ".
           IF KARAR=1 GO TAKIM-IPTAL-ET.
           IF KARAR=2 GO TAKIM-NO-OKU.
           GO TAKIM-IPTAL.
       TAKIM-IPTAL-ET.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           OPEN I-O TAKIMDOS.
           DELETE TAKIMDOS INVALID DISPLAY (2,2) "*".
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                           TAKIM TABLOSU                     * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       TAKIM-TABLOSU.
           OPEN INPUT TAKIMDOS.
           DISPLAY "~W=TABLO,NOESC,NOWAIT,NOCLEAR/".
           MOVE ZEROS TO TAKIM-NO.
           START TAKIMDOS KEY NOT LESS THAN TAKIM-KEY
                             INVALID GO TAKIM-TABLO-CIK.
           MOVE 1 TO TAB-SECIM TAB-ESSEC. MOVE 0 TO TAB-SAY.
           MOVE SPACES TO TAKIM-DIZISI.
       TAKIM-TABLO-OKU.
           READ TAKIMDOS NEXT AT END GO TAKIM-SAYFA-DOLDU.
           ADD 1 TO TAB-SAY.
           MOVE TAKIM-NO  TO TAKIM-DIZI-NO  (TAB-SAY).
           MOVE TAKIM-ADI TO TAKIM-DIZI-ADI (TAB-SAY).
           COMPUTE TAB-LIN=TAB-SAY + 3. MOVE TAB-SAY TO TAB-ESSEC.
           DISPLAY NORMAL-TAKIM-YAZ.
           IF TAB-SAY=18 GO TAKIM-SAYFA-DOLDU ELSE GO TAKIM-TABLO-OKU.
       TAKIM-SAYFA-DOLDU.
           IF TAB-SAY=0 GO TAKIM-TABLO-CIK.
           DISPLAY (2,79) " ". PERFORM TAKIM-TABLO-KONTROL.
           CALL X"83" USING TAB-INTX. MOVE TAB-INTX TO TAB-DEG.
           IF TAB-ESC   GO TAKIM-TABLO-CIK.
           IF TAB-ENTER GO TAKIM-TABLO-SECME-ISLEMI.
           IF TAB-ASAGI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=TAB-SAY MOVE 1 TO TAB-SECIM 
                             ELSE ADD  1 TO TAB-SECIM.
           IF TAB-YUKARI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=1 MOVE TAB-SAY TO TAB-SECIM 
                       ELSE SUBTRACT 1 FROM TAB-SECIM.
           GO TAKIM-SAYFA-DOLDU.
       TAKIM-TABLO-KONTROL.
           COMPUTE TAB-LIN=TAB-ESSEC + 3. DISPLAY NORMAL-TAKIM-YAZ.
           COMPUTE TAB-LIN=TAB-SECIM + 3. DISPLAY PARLAK-TAKIM-YAZ.
       TAKIM-TABLO-SECME-ISLEMI.
           CLOSE TAKIMDOS. DISPLAY "~C=LAST/".
           MOVE TAKIM-DIZI-NO (TAB-SECIM) TO EKR-TAKIM-NO.
           GO TAKIM-TABLO-SON.
       TAKIM-TABLO-CIK.
           CLOSE TAKIMDOS. DISPLAY "~C=LAST/".
           MOVE ZEROS TO EKR-TAKIM-NO.
       TAKIM-TABLO-SON.
           EXIT.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      *> Alt Perform Sahalar.
       OTOMATIK-TAKIM-NO.
           MOVE ZEROS TO EKR-TAKIM-NO.
           OPEN INPUT TAKIMDOS.
           MOVE 99 TO TAKIM-NO.
           START TAKIMDOS KEY NOT GREATER THAN TAKIM-KEY
                             INVALID GO OTOMATIK-SON.
       OTOMATIK-OKU.
           READ TAKIMDOS NEXT AT END GO OTOMATIK-SON.
           MOVE TAKIM-NO TO EKR-TAKIM-NO.
       OTOMATIK-SON.
           CLOSE TAKIMDOS.   ADD 1 TO EKR-TAKIM-NO.
           PERFORM SIFIRLA.  DISPLAY TAKIM-BILGILERI.
      *>
       ONCEKI-KAYIT.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           START TAKIMDOS KEY LESS THAN TAKIM-KEY INVALID GO ONCEKI-SON.
       ONCEKI-OKU.
           READ TAKIMDOS PREVIOUS AT END GO ONCEKI-SON.
           MOVE TAKIM-NO TO EKR-TAKIM-NO.
           DISPLAY TAKIM-BILGILERI.
       ONCEKI-SON.
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
      *>
       SONRAKI-KAYIT.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           START TAKIMDOS KEY GREATER THAN TAKIM-KEY 
                             INVALID GO SONRAKI-SON.
       SONRAKI-OKU.
           READ TAKIMDOS NEXT AT END GO SONRAKI-SON.
           MOVE TAKIM-NO TO EKR-TAKIM-NO.
           DISPLAY TAKIM-BILGILERI.
       SONRAKI-SON.
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
      *>
       LIG-VE-TARIHI-YAZ.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           DISPLAY (2,70) BU-GUN.  DISPLAY (2,72) "/".
           DISPLAY (2,73) BU-AY.   DISPLAY (2,75) "/".
           DISPLAY (2,76) BU-YIL.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-KAYDI
                     ELSE READ LIGDOS AT END DISPLAY (2,2) "*".
           CLOSE LIGDOS.
           DISPLAY (2,4) LIG-ADI.
       SIFIRLA. MOVE SPACES TO TAKIM-ADI.
       ESC-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
      *> Programdan k.
       PROGRAM-SONU.
           EXIT PROGRAM.
