program Euler;
uses Dos;
const
  DecimalCount : Word = 0;
type
  TTime = record
    Hour : Word;
    Minute : Word;
    Second : Word;
    Sec100 : Word;
  end;

  TNumber = array[0..10005] of ShortInt;

var
  BeginningTime : TTime;
  EndingTime : TTime;
  Term1 : TNumber;
  Term2 : TNumber;
  Size : Word;
  I : Word;

procedure Multiply(var Arr : TNumber; Size : Word; Multiplier : Word);
var
  Carry : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Carry := 0;
  for I := Size downto 0 do
  begin
    Temp := Multiplier * Arr[I] + Carry;
    Arr[I] := Temp mod 10;
    Carry := Temp div 10;
  end;
end;

procedure Divide(var Arr : TNumber; Size : Word; Divisor : Word);
var
  Remainder : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Remainder := 0;
  for I := 0 to Size do
  begin
    Temp := 10 * Remainder + Arr[I];
    Arr[I] := Temp div Divisor;
    Remainder := Temp mod Divisor;
  end;
end;

procedure Add(var Arr1, Arr2 : TNumber; Size : Word);
var
  Carry : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Carry := 0;
  for I := Size downto 0 do
  begin
    Temp := Arr1[I] + Arr2[I] + Carry;
    Arr1[I] := Temp mod 10;
    Carry := Temp div 10;
  end;
end;

procedure Sub(var Arr1, Arr2 : TNumber; Size : Word);
var
  I : Word;
begin
  for I := Size downto 0 do
  begin
    if Arr1[I] < Arr2[I] then
    begin
      Inc(Arr1[I], 10);
      Dec(Arr1[I - 1]);
    end;
    Arr1[I] := Arr1[I] - Arr2[I];
  end;
end;

begin
  Write('Input number of decimal places : ');
  Readln(Size);
  with BeginningTime do GetTime(Hour, Minute, Second, Sec100);
  if Size > 10000 then
  begin
    Write('Size must be less then 10000');
    Halt(1);
  end;
  Inc(Size, 5);
  FillChar(Term1, Succ(Size), 0);
  Term1[0] := 2;
  FillChar(Term2, Succ(Size), 0);
  Term2[0] := 1;
  I := 2;
  repeat
    Inc(DecimalCount, Round(Ln(I) / Ln(10)));
    Divide(Term2, Size, I);
    Add(Term1, Term2, Size);
    Inc(I);
  until DecimalCount > Size;
  Writeln;
  Write('e = 2.');
  for I := 1 to Size - 5 do
  begin
    Write(Term1[I]);
    if (I mod 5) = 0 then Write(' ');
    if (I mod 50) = 0 then Write(#10,#13,'       ');
  end;
  with EndingTime do GetTime(Hour, Minute, Second, Sec100);
  Writeln;
  with BeginningTime do Writeln('Beginning Time : ',
                                Hour, ':', Minute, ':', Second, ':', Sec100);
  with EndingTime do Writeln('Ending Time : ',
                                Hour, ':', Minute, ':', Second, ':', Sec100);
end.