program PiCalc;
uses Dos;
type
  TTime = record
    Hour : Word;
    Minute : Word;
    Second : Word;
    Sec100 : Word;
  end;

  TNumber = array[0..10005] of ShortInt;

var
  BeginningTime : TTime;
  EndingTime : TTime;
  Term1 : TNumber;
  Term2 : TNumber;
  Size : Word;
  I : Word;

procedure Multiply(var Arr : TNumber; Size : Word; Multiplier : Word);
var
  Carry : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Carry := 0;
  for I := Size downto 0 do
  begin
    Temp := Multiplier * Arr[I] + Carry;
    Arr[I] := Temp mod 10;
    Carry := Temp div 10;
  end;
end;

procedure Divide(var Arr : TNumber; Size : Word; Divisor : Word);
var
  Remainder : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Remainder := 0;
  for I := 0 to Size do
  begin
    Temp := 10 * Remainder + Arr[I];
    Arr[I] := Temp div Divisor;
    Remainder := Temp mod Divisor;
  end;
end;

procedure Add(var Arr1, Arr2 : TNumber; Size : Word);
var
  Carry : LongInt;
  Temp : LongInt;
  I : Word;
begin
  Carry := 0;
  for I := Size downto 0 do
  begin
    Temp := Arr1[I] + Arr2[I] + Carry;
    Arr1[I] := Temp mod 10;
    Carry := Temp div 10;
  end;
end;

procedure Sub(var Arr1, Arr2 : TNumber; Size : Word);
var
  I : Word;
begin
  for I := Size downto 0 do
  begin
    if Arr1[I] < Arr2[I] then
    begin
      Inc(Arr1[I], 10);
      Dec(Arr1[I - 1]);
    end;
    Arr1[I] := Arr1[I] - Arr2[I];
  end;
end;

procedure ArcTangent(var Arr : TNumber; Size : Word; X : Word);
var
  Term : TNumber;
  I : Integer;
  SqrX : Word;
begin
  FillChar(Arr, Succ(Size), 0);
  Arr[0] := 1;
  SqrX := X * X;
  I := Size shl 1 + 1;
  Divide(Arr, Size, I);
  Divide(Arr, Size, SqrX);
  repeat
    FillChar(Term, Succ(Size), 0);
    Term[0] := 1;
    Divide(Term, Size, I);
    Sub(Term, Arr, Size);
    Move(Term, Arr, Succ(Size));
    Divide(Arr, Size, SqrX);
    Dec(I, 2);
  until I < 3;
  FillChar(Term, Size, 9);
  Term[0] := 0;
  Term[Size] := 10;
  Sub(Term, Arr, Size);
  Move(Term, Arr, Succ(Size));
  Divide(Arr, Size, X);
end;

begin
  Write('Input number of decimal places : ');
  Readln(Size);
  with BeginningTime do GetTime(Hour, Minute, Second, Sec100);
  if Size > 10000 then
  begin
    Writeln('Size must be less then 10000');
    Halt(1);
  end;
  Inc(Size, 5);
  ArcTangent(Term1, Size, 5);
  ArcTangent(Term2, Size, 239);
  Multiply(Term1, Size, 4);
  Sub(Term1, Term2, Size);
  Multiply(Term1, Size, 4);
  Writeln;
  Write('Pi = 3.');
  for I := 1 to Size - 5 do
  begin
    Write(Term1[I]);
    if (I mod 5) = 0 then Write(' ');
    if (I mod 50) = 0 then Write(#10,#13,'       ');
  end;
  with EndingTime do GetTime(Hour, Minute, Second, Sec100);
  Writeln;
  with BeginningTime do Writeln('Beginning Time : ',
                                Hour, ':', Minute, ':', Second, ':', Sec100);
  with EndingTime do Writeln('Ending Time : ',
                                Hour, ':', Minute, ':', Second, ':', Sec100);
end.